#ifndef __common_hpp__
#define __common_hpp__

#include <rtt/TaskContext.hpp>
#include <rtt/Property.hpp>
#include <rtt/Port.hpp>
#include <rtt/Operation.hpp>

struct Foo : public RTT::TaskContext
{
 
  RTT::OutputPort<double> m_output;
       
  Foo(std::string name) : 
    RTT::TaskContext(name, PreOperational),
    m_output("output")
  {
    // operations
    addOperation("getDiskUsage", &Foo::getDiskUsage, this , RTT::ClientThread).doc("Get disk usage in %.");
    // ports
    addPort     ("output"      , m_output);
  }

  double getDiskUsage(void) const
  {
    static double du = 0;
    return du++;
  }

  void updateHook()
  {
    static double counter = 0;
    m_output.write(counter++);
  }

};

bool test_props(RTT::TaskContext &tc);
bool test_ports(RTT::TaskContext &tc);


#endif /* __common_hpp__ */
